summaryrefslogtreecommitdiff
path: root/scripts/min-tool-version.sh
diff options
context:
space:
mode:
authorMasahiro Yamada <masahiroy@kernel.org>2021-03-16 01:12:55 +0900
committerMasahiro Yamada <masahiroy@kernel.org>2021-04-25 05:14:26 +0900
commite24b3ffcf4216d819b52618b6f17ba7410d1d845 (patch)
tree744a4dcc8d480a9f54bb88cecbcdeaec17f2e43d /scripts/min-tool-version.sh
parent6e0839fda3f8598b164a7f23f3eec039e2db5fbc (diff)
kbuild: collect minimum tool versions into scripts/min-tool-version.sh
The kernel build uses various tools, many of which are provided by the same software suite, for example, LLVM and Binutils. When you raise the minimum version of Clang/LLVM, you need to update clang_min_version in scripts/cc-version.sh and also lld_min_version in scripts/ld-version.sh. Kbuild can handle CC=clang and LD=ld.lld independently, but it does not make much sense to maintain their versions separately. Let's create a central place of minimum tool versions so you do not need to touch multiple files. scripts/min-tool-version.sh prints the minimum version of the given tool. Signed-off-by: Masahiro Yamada <masahiroy@kernel.org> Reviewed-by: Nathan Chancellor <nathan@kernel.org> Acked-by: Miguel Ojeda <ojeda@kernel.org> Tested-by: Sedat Dilek <sedat.dilek@gmail.com>
Diffstat (limited to 'scripts/min-tool-version.sh')
-rwxr-xr-xscripts/min-tool-version.sh39
1 files changed, 39 insertions, 0 deletions
diff --git a/scripts/min-tool-version.sh b/scripts/min-tool-version.sh
new file mode 100755
index 000000000000..d22cf91212b0
--- /dev/null
+++ b/scripts/min-tool-version.sh
@@ -0,0 +1,39 @@
+#!/bin/sh
+# SPDX-License-Identifier: GPL-2.0-only
+#
+# Print the minimum supported version of the given tool.
+# When you raise the minimum version, please update
+# Documentation/process/changes.rst as well.
+
+set -e
+
+if [ $# != 1 ]; then
+ echo "Usage: $0 toolname" >&2
+ exit 1
+fi
+
+case "$1" in
+binutils)
+ echo 2.23.0
+ ;;
+gcc)
+ # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=63293
+ # https://lore.kernel.org/r/20210107111841.GN1551@shell.armlinux.org.uk
+ if [ "$SRCARCH" = arm64 ]; then
+ echo 5.1.0
+ else
+ echo 4.9.0
+ fi
+ ;;
+icc)
+ # temporary
+ echo 16.0.3
+ ;;
+llvm)
+ echo 10.0.1
+ ;;
+*)
+ echo "$1: unknown tool" >&2
+ exit 1
+ ;;
+esac